SELECT       DimProductCategory.EnglishProductCategoryName AS ProductCategory, DimProductSubcategory.EnglishProductSubcategoryName AS ProductSubcategory, 
             DimProduct.EnglishProductName AS ProductName, SUM(FactResellerSales.SalesAmount) AS ResellerSales, SUM(FactInternetSales.SalesAmount) 
             AS InternetSales
FROM         DimProduct INNER JOIN
             DimProductSubcategory ON DimProduct.ProductSubcategoryKey = DimProductSubcategory.ProductSubcategoryKey INNER JOIN
             DimProductCategory ON DimProductSubcategory.ProductCategoryKey = DimProductCategory.ProductCategoryKey INNER JOIN
             FactInternetSales ON DimProduct.ProductKey = FactInternetSales.ProductKey INNER JOIN
             FactResellerSales ON DimProduct.ProductKey = FactResellerSales.ProductKey INNER JOIN
             DimDate AS D ON FactInternetSales.OrderDateKey = D.DateKey AND FactResellerSales.OrderDateKey = D.DateKey
GROUP BY DimProduct.EnglishProductName, DimProductCategory.EnglishProductCategoryName, DimProductSubcategory.EnglishProductSubcategoryName
ORDER BY ProductCategory, ProductSubcategory, ProductName
