SELECT     SOH.SalesOrderNumber, S.Name AS Store, SOH.OrderDate, P.FirstName AS SalesFirstName, P.LastName AS SalesLastName, P.Title AS SalesTitle, 
                      SOH.PurchaseOrderNumber, SM.Name AS ShipMethod, BA.AddressLine1 AS BillAddress1, BA.AddressLine2 AS BillAddress2, BA.City AS BillCity, 
                      BA.PostalCode AS BillPostalCode, BSP.Name AS BillStateProvince, BCR.Name AS BillCountryRegion, SA.AddressLine1 AS ShipAddress1, 
                      SA.AddressLine2 AS ShipAddress2, SA.City AS ShipCity, SA.PostalCode AS ShipPostalCode, SSP.Name AS ShipStateProvince, SCR.Name AS ShipCountryRegion
FROM         Person.Address AS BA INNER JOIN
                      Person.StateProvince AS BSP ON BA.StateProvinceID = BSP.StateProvinceID INNER JOIN
                      Person.CountryRegion AS BCR ON BSP.CountryRegionCode = BCR.CountryRegionCode RIGHT OUTER JOIN
                      Sales.SalesOrderHeader AS SOH LEFT OUTER JOIN
                      Person.Person AS P ON SOH.SalesPersonID = P.BusinessEntityID ON BA.AddressID = SOH.BillToAddressID LEFT OUTER JOIN
                      Person.Address AS SA INNER JOIN
                      Person.StateProvince AS SSP ON SA.StateProvinceID = SSP.StateProvinceID INNER JOIN
                      Person.CountryRegion AS SCR ON SSP.CountryRegionCode = SCR.CountryRegionCode ON SOH.ShipToAddressID = SA.AddressID LEFT OUTER JOIN
                      Purchasing.ShipMethod AS SM ON SOH.ShipMethodID = SM.ShipMethodID LEFT OUTER JOIN
                      Sales.Store AS S ON SOH.CustomerID = S.BusinessEntityID
WHERE       (SOH.SalesOrderNumber = @SalesOrderNumber)