using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;
using System.IO;
using System.Net;
using System.Text;
using System.IO.IsolatedStorage;
using System.Diagnostics;
using System.Web.Services.Protocols;
using IntegrationOptions.ReportExecution;
using RS=IntegrationOptions.ReportService;

namespace IntegrationOptions
{
	/// <summary>
	/// Summary description for AccessOptons.
	/// </summary>
	public class IntegrationOptions : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lblFolder;
		private System.Windows.Forms.Label lblServer;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox grpIntegrationOptions;
		private System.Windows.Forms.RadioButton radURLWebBrowser;
		private System.Windows.Forms.RadioButton radWS;
		private System.Windows.Forms.DataGrid grdParams;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Button btnRun;
		private System.Windows.Forms.TextBox txtFolder;
		private System.Windows.Forms.TextBox txtServer;
		private System.Windows.Forms.ComboBox cmbFormat;
        private System.Windows.Forms.Label lblFormat;
        private ComboBox cmbReports;
        private Label label1;
        private Button btnGetReports;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
        private RadioButton radURLStream;
        private RadioButton radURLShell;
        private ExecutionInfo2 _execInfo = null;
        private const string ROOT_PREFIX = "img";


		public IntegrationOptions()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(IntegrationOptions));
            this.txtFolder = new System.Windows.Forms.TextBox();
            this.lblFolder = new System.Windows.Forms.Label();
            this.btnRun = new System.Windows.Forms.Button();
            this.lblServer = new System.Windows.Forms.Label();
            this.txtServer = new System.Windows.Forms.TextBox();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.cmbReports = new System.Windows.Forms.ComboBox();
            this.label1 = new System.Windows.Forms.Label();
            this.btnGetReports = new System.Windows.Forms.Button();
            this.cmbFormat = new System.Windows.Forms.ComboBox();
            this.lblFormat = new System.Windows.Forms.Label();
            this.grdParams = new System.Windows.Forms.DataGrid();
            this.grpIntegrationOptions = new System.Windows.Forms.GroupBox();
            this.radURLShell = new System.Windows.Forms.RadioButton();
            this.radURLStream = new System.Windows.Forms.RadioButton();
            this.radURLWebBrowser = new System.Windows.Forms.RadioButton();
            this.radWS = new System.Windows.Forms.RadioButton();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.grdParams)).BeginInit();
            this.grpIntegrationOptions.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.SuspendLayout();
            // 
            // txtFolder
            // 
            this.txtFolder.Location = new System.Drawing.Point(86, 56);
            this.txtFolder.Name = "txtFolder";
            this.txtFolder.Size = new System.Drawing.Size(132, 20);
            this.txtFolder.TabIndex = 1;
            this.txtFolder.Text = "/AMRS";
            // 
            // lblFolder
            // 
            this.lblFolder.Location = new System.Drawing.Point(16, 56);
            this.lblFolder.Name = "lblFolder";
            this.lblFolder.Size = new System.Drawing.Size(72, 16);
            this.lblFolder.TabIndex = 18;
            this.lblFolder.Text = "Folder:";
            // 
            // btnRun
            // 
            this.btnRun.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btnRun.Font = new System.Drawing.Font("Microsoft Sans Serif", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnRun.Image = ((System.Drawing.Image)(resources.GetObject("btnRun.Image")));
            this.btnRun.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnRun.Location = new System.Drawing.Point(324, 365);
            this.btnRun.Name = "btnRun";
            this.btnRun.Size = new System.Drawing.Size(112, 23);
            this.btnRun.TabIndex = 14;
            this.btnRun.Text = "Run Report";
            this.btnRun.Click += new System.EventHandler(this.btnRun_Click);
            // 
            // lblServer
            // 
            this.lblServer.Location = new System.Drawing.Point(16, 24);
            this.lblServer.Name = "lblServer";
            this.lblServer.Size = new System.Drawing.Size(64, 20);
            this.lblServer.TabIndex = 20;
            this.lblServer.Text = "Server Url:";
            // 
            // txtServer
            // 
            this.txtServer.Location = new System.Drawing.Point(86, 24);
            this.txtServer.Name = "txtServer";
            this.txtServer.ReadOnly = true;
            this.txtServer.Size = new System.Drawing.Size(224, 20);
            this.txtServer.TabIndex = 0;
            this.txtServer.Text = "http://localhost/reportserver";
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.cmbReports);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.btnGetReports);
            this.groupBox1.Controls.Add(this.cmbFormat);
            this.groupBox1.Controls.Add(this.lblServer);
            this.groupBox1.Controls.Add(this.txtServer);
            this.groupBox1.Controls.Add(this.lblFolder);
            this.groupBox1.Controls.Add(this.txtFolder);
            this.groupBox1.Controls.Add(this.lblFormat);
            this.groupBox1.Location = new System.Drawing.Point(8, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(434, 154);
            this.groupBox1.TabIndex = 21;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Report";
            // 
            // cmbReports
            // 
            this.cmbReports.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cmbReports.Location = new System.Drawing.Point(86, 123);
            this.cmbReports.Name = "cmbReports";
            this.cmbReports.Size = new System.Drawing.Size(224, 21);
            this.cmbReports.TabIndex = 3;
            this.cmbReports.SelectedIndexChanged += new System.EventHandler(this.cmbReports_SelectedIndexChanged);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(16, 126);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(64, 16);
            this.label1.TabIndex = 23;
            this.label1.Text = "Report:";
            // 
            // btnGetReports
            // 
            this.btnGetReports.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btnGetReports.Font = new System.Drawing.Font("Microsoft Sans Serif", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnGetReports.Image = ((System.Drawing.Image)(resources.GetObject("btnGetReports.Image")));
            this.btnGetReports.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnGetReports.Location = new System.Drawing.Point(316, 121);
            this.btnGetReports.Name = "btnGetReports";
            this.btnGetReports.Size = new System.Drawing.Size(112, 23);
            this.btnGetReports.TabIndex = 22;
            this.btnGetReports.Text = "Get Reports";
            this.btnGetReports.Click += new System.EventHandler(this.btnGetReports_Click);
            // 
            // cmbFormat
            // 
            this.cmbFormat.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cmbFormat.Location = new System.Drawing.Point(86, 89);
            this.cmbFormat.Name = "cmbFormat";
            this.cmbFormat.Size = new System.Drawing.Size(132, 21);
            this.cmbFormat.TabIndex = 2;
            // 
            // lblFormat
            // 
            this.lblFormat.Location = new System.Drawing.Point(16, 92);
            this.lblFormat.Name = "lblFormat";
            this.lblFormat.Size = new System.Drawing.Size(42, 16);
            this.lblFormat.TabIndex = 18;
            this.lblFormat.Text = "Format:";
            // 
            // grdParams
            // 
            this.grdParams.DataMember = "";
            this.grdParams.FlatMode = true;
            this.grdParams.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.grdParams.Location = new System.Drawing.Point(8, 24);
            this.grdParams.Name = "grdParams";
            this.grdParams.PreferredColumnWidth = 150;
            this.grdParams.Size = new System.Drawing.Size(420, 88);
            this.grdParams.TabIndex = 22;
            // 
            // grpIntegrationOptions
            // 
            this.grpIntegrationOptions.Controls.Add(this.radURLShell);
            this.grpIntegrationOptions.Controls.Add(this.radURLStream);
            this.grpIntegrationOptions.Controls.Add(this.radURLWebBrowser);
            this.grpIntegrationOptions.Controls.Add(this.radWS);
            this.grpIntegrationOptions.Location = new System.Drawing.Point(8, 296);
            this.grpIntegrationOptions.Name = "grpIntegrationOptions";
            this.grpIntegrationOptions.Size = new System.Drawing.Size(249, 92);
            this.grpIntegrationOptions.TabIndex = 23;
            this.grpIntegrationOptions.TabStop = false;
            this.grpIntegrationOptions.Text = "View Report By";
            // 
            // radURLShell
            // 
            this.radURLShell.Location = new System.Drawing.Point(8, 42);
            this.radURLShell.Name = "radURLShell";
            this.radURLShell.Size = new System.Drawing.Size(132, 24);
            this.radURLShell.TabIndex = 11;
            this.radURLShell.Text = "URL Shell";
            // 
            // radURLStream
            // 
            this.radURLStream.Location = new System.Drawing.Point(8, 64);
            this.radURLStream.Name = "radURLStream";
            this.radURLStream.Size = new System.Drawing.Size(124, 24);
            this.radURLStream.TabIndex = 12;
            this.radURLStream.Text = "URL Stream";
            // 
            // radURLWebBrowser
            // 
            this.radURLWebBrowser.Checked = true;
            this.radURLWebBrowser.Location = new System.Drawing.Point(8, 21);
            this.radURLWebBrowser.Name = "radURLWebBrowser";
            this.radURLWebBrowser.Size = new System.Drawing.Size(132, 24);
            this.radURLWebBrowser.TabIndex = 10;
            this.radURLWebBrowser.TabStop = true;
            this.radURLWebBrowser.Text = "URL Web Browser";
            // 
            // radWS
            // 
            this.radWS.Location = new System.Drawing.Point(154, 21);
            this.radWS.Name = "radWS";
            this.radWS.Size = new System.Drawing.Size(124, 24);
            this.radWS.TabIndex = 13;
            this.radWS.Text = "Web service";
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.grdParams);
            this.groupBox3.Location = new System.Drawing.Point(8, 168);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(434, 120);
            this.groupBox3.TabIndex = 24;
            this.groupBox3.TabStop = false;
            this.groupBox3.Text = "Parameters";
            // 
            // IntegrationOptions
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(449, 398);
            this.Controls.Add(this.groupBox3);
            this.Controls.Add(this.grpIntegrationOptions);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.btnRun);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Name = "IntegrationOptions";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Integration Options";
            this.Load += new System.EventHandler(this.IntegrationOptons_Load);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.AccessOptions_Closing);
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.grdParams)).EndInit();
            this.grpIntegrationOptions.ResumeLayout(false);
            this.groupBox3.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion



		private void IntegrationOptons_Load(object sender, System.EventArgs e)
		{
			LoadUserSettings();
			LoadFormats();
            ConfigureUI();
            
		}
        private void ConfigureUI()
        {
            cmbReports.Enabled = cmbReports.Items.Count > 0;
            btnRun.Enabled = cmbReports.Items.Count>0;
        }

        private void btnGetReports_Click(object sender, EventArgs e)
        {
            try
            {
                this.Cursor = Cursors.WaitCursor;
                LoadReports();
                if (cmbReports.SelectedIndex > -1) LoadReportParameters();
                ConfigureUI();
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }
        }
        /// <summary>
        /// Loads reports from the report catalog using the ListChildren API.
        /// </summary>
        private void LoadReports()
        {
            RS.ReportingService2005 rs = new RS.ReportingService2005();
            rs.Credentials = System.Net.CredentialCache.DefaultCredentials;
            try
            {
                RS.CatalogItem[] items = rs.ListChildren(txtFolder.Text, false);

                foreach (RS.CatalogItem item in items)
                {
                    if (item.Type == ReportService.ItemTypeEnum.Report) cmbReports.Items.Add(item.Name);
                }

                if (cmbReports.Items.Count > 0) cmbReports.SelectedIndex = 0;
            }
            catch (Exception ex)
            {
                Util.ShowErrorMessage(ex.Message);
            }
            
        }

        /// <summary>
        /// Loads report parameters for a given report and shows them in the UI
        /// </summary>
        private void LoadReportParameters()
        {
            ReportExecutionService rs = new ReportExecutionService();
            rs.Credentials = System.Net.CredentialCache.DefaultCredentials;
            _execInfo = rs.LoadReport2(this.ReportPath, null);

            EntityParameter.ParametersDataTable userParameters = new EntityParameter.ParametersDataTable();
            foreach (ReportParameter p in _execInfo.Parameters)
            {
                userParameters.AddParametersRow(p.Name, String.Join(",", p.DefaultValues));
            }
            userParameters.DefaultView.AllowNew = false;
            userParameters.DefaultView.AllowDelete = false;
            userParameters.Columns[0].ReadOnly = true;
            grdParams.DataSource = userParameters;
        }

        /// <summary>
        /// Load visible export formats (except HTML4.0) and shows them in the UI
        /// </summary>
		private void LoadFormats()
		{
            ReportExecutionService rs = new ReportExecutionService();
            rs.Credentials = System.Net.CredentialCache.DefaultCredentials;
			Extension[] extensions = null;

            cmbFormat.Items.Clear();
			// Retrieve a list of all supported rendering extensions. 
			try
			{
				extensions = rs.ListRenderingExtensions();

				if (extensions != null)
				{
					foreach (Extension extension in extensions)
					{
						if (extension.Visible || extension.Name.StartsWith("HTML4.0")) cmbFormat.Items.Add(extension.Name);
					}
					cmbFormat.Text = "PDF";
				}
			}

			catch (SoapException ex)
			{
				Util.ShowErrorMessage(ex);
			}
		}

        private void btnRun_Click(object sender, System.EventArgs e)
        {
            try
            {
                this.Cursor = Cursors.WaitCursor;

                if (radURLWebBrowser.Checked)
                {
                    if (cmbFormat.Text == "HTML4.0")
                        RunByURLWebBrowser();
                    else
                        RunByURLShell();  
                }
                else if (radURLShell.Checked)
                    RunByURLShell();
                else if (radURLStream.Checked)
                    RunByURLStream();
                else
                    RunByWS();
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }
        }

        private string ReportURL
        {
            get
            {
                StringBuilder urlBuilder = new StringBuilder();
                urlBuilder.Append(txtServer.Text);
                urlBuilder.Append("?");
                urlBuilder.Append(this.ReportPath);

                // get a reference to the grid data source
                EntityParameter.ParametersDataTable table = (EntityParameter.ParametersDataTable)grdParams.DataSource;

                // populate the parameters collection
                foreach (EntityParameter.ParametersRow row in table.Rows)
                {
                    string[] parameters = row.Value.Split(new char[] { ',' });
                    foreach (string p in parameters)
                    {
                        urlBuilder.Append(String.Format("&{0}={1}", row.Name, p));
                    }
                }
                urlBuilder.Append(@"&rs:Format=" + cmbFormat.Text);
                urlBuilder.Append(@"&rs:Command=Render");
                

                string url = urlBuilder.ToString();
                return url;
            }
        }


        /// <summary>
        /// URL access with shelling the report
        /// </summary>
        private void RunByURLShell()
        {
           Process.Start("IExplore", this.ReportURL); // shell to explorer
        }
        /// <summary>
        /// URL access with dispaying the report in the WebBrowser control
        /// </summary>
        private void RunByURLWebBrowser()
        {
            ReportBrowser reportBrowser = new ReportBrowser(); // display in the WebBrowser control
            reportBrowser.RenderReport(this.ReportURL);
            reportBrowser.Show();
        }
        /// <summary>
        /// URL access with streaming
        /// </summary>
        private void RunByURLStream()
        {
            string url = this.ReportURL;
            if (cmbFormat.Text.StartsWith("HTML")) url += "&rc:Toolbar=false";

            WebRequest request = WebRequest.Create(url);
            request.UseDefaultCredentials = true;
            string filePath = Util.GetFileForReport(url, cmbFormat.Text);

            using (WebResponse response = request.GetResponse())
            using (Stream readStream = response.GetResponseStream())
            using (FileStream writeStream = new FileStream(filePath, FileMode.Create))
            {
                byte[] readBuffer = new byte[4096];
                int bytesRead = 0;
                while ((bytesRead = readStream.Read(readBuffer, 0, readBuffer.Length)) != 0)
                {
                    writeStream.Write(readBuffer, 0, bytesRead);
                }
            }
            Process.Start(filePath);
        }
        /// <summary>
        /// Web service
        /// </summary>
        private void RunByWS()
        {
            ReportExecutionService rs = new ReportExecutionService();
            rs.Credentials = System.Net.CredentialCache.DefaultCredentials;
            // Render arguments
            byte[] result = null;
            string reportPath = txtFolder.Text;
            string extension;
            string format = cmbFormat.Text;
            string devInfo = String.Format("<DeviceInfo><StreamRoot>{0}</StreamRoot></DeviceInfo>", ROOT_PREFIX);
            string encoding;
            string mimeType;
            Warning[] warnings = null;
            string[] streamIDs = null;
            string optionalString = null;

            try
            {
                rs.ExecutionHeaderValue = new ExecutionHeader();
                rs.ExecutionHeaderValue.ExecutionID = _execInfo.ExecutionID;

                ParameterValue[] parameters = this.GetSoapParameters;
                rs.SetExecutionParameters2(parameters, null);

                result = rs.Render2(format, devInfo, PageCountMode.Estimate, out extension, out mimeType, out encoding, out warnings, out streamIDs);

                // When exporting to HTML, render the report images as streams
                // so they show up after the execution sesssion expires
                if ("ht" == format.Substring(0, 2).ToLower())
                {
                    foreach (string streamID in streamIDs)
                    {
                        byte[] image = rs.RenderStream(format, streamID, null, out optionalString, out optionalString);
                        FileStream stream = File.OpenWrite(String.Format("{0}{1}{2}{3}", Application.UserAppDataPath, Path.DirectorySeparatorChar, ROOT_PREFIX, streamID));
                        stream.Write(image, 0, image.Length);
                        stream.Close();
                    }
                }
            }
            catch (SoapException ex)
            {
                Debug.WriteLine(ex.Detail.OuterXml);
                switch (ex.Detail["ErrorCode"].InnerText)
                {
                    case "rsReportParameterValueNotSet":
                        Util.ShowErrorMessage("The report parameters do not match.\n" + ex.Detail.InnerText); break;
                    case "rsItemNotFound":
                        Util.ShowErrorMessage("Wrong report name."); break;
                    case "rsExecutionNotFound":
                        Util.ShowErrorMessage("Session has expired. Please refresh the report."); break;

                    default: throw;
                }
            }
            // Write the contents of the report to a file.
            try
            {
                string filePath = Util.GetFileForReport(reportPath, cmbFormat.Text);
                FileStream stream = File.Create(filePath, result.Length);
                stream.Write(result, 0, result.Length);
                stream.Close();
                Process.Start(filePath);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        /// <summary>
        /// Returns the count of the effective report parameters (multivalue parameters add up to the count)
        /// </summary>
        private int ParameterCount
        {
            get
            {
                int i;
                int parametersCount = 0;
                EntityParameter.ParametersDataTable userParameters = (EntityParameter.ParametersDataTable)grdParams.DataSource;

                for (i = 0; i < userParameters.Rows.Count; i++)
                {

                    int multiValueCount = userParameters[i].Value.Split(new char[] { ',' }).Length;
                    parametersCount++;
                    parametersCount += multiValueCount > 1 ? multiValueCount - 1 : 0;
                }
                return parametersCount;
            }
        }

        /// <summary>
        /// Returns an array of the parameters to pass to the Render API
        /// </summary>
        private ParameterValue[] GetSoapParameters
        {
            get
            {
                int i = 0;
                EntityParameter.ParametersDataTable userParameters = (EntityParameter.ParametersDataTable)grdParams.DataSource;
                ParameterValue[] parameters = new ParameterValue[this.ParameterCount];
                foreach (ReportParameter p in _execInfo.Parameters)
                {
                    if (!p.MultiValue) 
                    {
                        parameters[i] = new ParameterValue();
                        parameters[i].Name = p.Name;
                        parameters[i].Value = userParameters[i].Value;
                    }
                    else
                    {
                        string[] multiValues = userParameters[i].Value.Split(new char[] { ',' });
                        for (int j=0; j<multiValues.Length; j++)
                        {
                            i += j;
                            parameters[i] = new ParameterValue();
                            parameters[i].Name = p.Name;
                            parameters[i].Value = multiValues[j];
                        }
                    }
                    i++;
                }
                return parameters;
            }
            
        }
 



		/// <summary>
		/// Gets the user settings from isolated storage
		/// </summary>
		void LoadUserSettings() 
		{
            txtServer.Text = Properties.Settings.Default.ReportServerUrl;
			try 
			{
				XmlDocument dom = new XmlDocument();
				using (Stream s = Util.GetSettingsStream(this.Name, FileMode.Open, FileAccess.Read, FileShare.Read)) 
				{
					dom.Load(s);
				}
				txtServer.Text		= dom.SelectSingleNode("//serverUrl").InnerText;
				txtFolder.Text		= dom.SelectSingleNode("//reportPath").InnerText;
			}
			catch {}  // no big deal if we fail - this is a convenience feature only
            btnGetReports.Select();
		}
		/// <summary>
		/// Saves the user preferences to the isolated storage
		/// </summary>
		void SaveUserSettings() 
		{
			try 
			{
				using (Stream s = Util.GetSettingsStream(this.Name, FileMode.Create, FileAccess.ReadWrite, FileShare.None)) 
				{
					XmlTextWriter w = new XmlTextWriter(s, System.Text.Encoding.UTF8);
					w.WriteStartElement(this.Name);
					w.WriteElementString("serverUrl",  txtServer.Text);
					w.WriteElementString("reportPath", txtFolder.Text);
					w.WriteEndElement();
					w.Close();
				}
			}
			catch {}  // no big deal if we fail - this is a convenience feature only
            
		}

        private string ReportPath
        {
            get
            {
                return String.Format("{0}/{1}", txtFolder.Text, cmbReports.Text);
            }
        }

		private void AccessOptions_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			SaveUserSettings();
		}



        private void cmbReports_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!cmbReports.Enabled) return;

            LoadReportParameters();
        }

	}
}
