using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;
using System.IO;
//using TestHarness.RS2005;
using System.Web.Services.Protocols;
using System.Diagnostics;
using Microsoft.Reporting.WinForms;

namespace TestHarness
{
	/// <summary>
	/// Summary description for TestHarness.
	/// </summary>
	public class TestHarness : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Button button1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.TextBox txtReportServer;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtReportPath;
		private System.Windows.Forms.Label label3;
        private Microsoft.Reporting.WinForms.ReportViewer reportViewer;
		private System.ComponentModel.IContainer components;

		public TestHarness()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{

			Application.Run(new TestHarness());
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.button1 = new System.Windows.Forms.Button();
            this.txtReportPath = new System.Windows.Forms.TextBox();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.label3 = new System.Windows.Forms.Label();
            this.txtReportServer = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.reportViewer = new Microsoft.Reporting.WinForms.ReportViewer();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.button1.Location = new System.Drawing.Point(8, 120);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(112, 23);
            this.button1.TabIndex = 0;
            this.button1.Text = "Test Report";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // txtReportPath
            // 
            this.txtReportPath.Location = new System.Drawing.Point(144, 56);
            this.txtReportPath.Name = "txtReportPath";
            this.txtReportPath.ScrollBars = System.Windows.Forms.ScrollBars.Horizontal;
            this.txtReportPath.Size = new System.Drawing.Size(304, 20);
            this.txtReportPath.TabIndex = 5;
            this.txtReportPath.Text = "/AMRS/TestDS";
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.txtReportPath);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.txtReportServer);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Location = new System.Drawing.Point(8, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(734, 96);
            this.groupBox1.TabIndex = 3;
            this.groupBox1.TabStop = false;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(24, 56);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(104, 24);
            this.label3.TabIndex = 6;
            this.label3.Text = "Report Server URL:";
            // 
            // txtReportServer
            // 
            this.txtReportServer.Location = new System.Drawing.Point(144, 24);
            this.txtReportServer.Name = "txtReportServer";
            this.txtReportServer.Size = new System.Drawing.Size(304, 20);
            this.txtReportServer.TabIndex = 3;
            this.txtReportServer.Text = "http://localhost/reportserver";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(24, 24);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(104, 24);
            this.label1.TabIndex = 4;
            this.label1.Text = "Report Server URL:";
            // 
            // reportViewer
            // 
            this.reportViewer.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.reportViewer.Location = new System.Drawing.Point(8, 152);
            this.reportViewer.Name = "reportViewer";
            this.reportViewer.Size = new System.Drawing.Size(736, 533);
            this.reportViewer.TabIndex = 4;
            // 
            // TestHarness
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(756, 697);
            this.Controls.Add(this.reportViewer);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.button1);
            this.Name = "TestHarness";
            this.Text = "Dataset Extension Test Harness";
            this.Load += new System.EventHandler(this.TestHarness_Load);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.TestHarness_Closing);
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

        /// <summary>
        /// Requests a remote report that runs under the context of the Report Server
        /// </summary>
        private void RunRemote()
        {
            try
            {
                this.Cursor = Cursors.WaitCursor;
                reportViewer.ProcessingMode = Microsoft.Reporting.WinForms.ProcessingMode.Remote;
                // Get the Report Server endpoint from the config file
                reportViewer.ServerReport.ReportServerUrl = new Uri(txtReportServer.Text);
                reportViewer.ServerReport.ReportPath = txtReportPath.Text;
                // Bind the dataset
                SetParameters();
                reportViewer.RefreshReport();

            }
            catch (Exception ex)
            {
                // Normally, we shouldn't reach the catch block, since exceptions are handled by 
                // the report viewer and error messages are displayed in the report pane
                // unless ReportError event is sinked. 
                throw ex;
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }
        }
        /// <summary>
        /// Set the report prameter for the Customer Orders report
        /// </summary>
        private void SetParameters()
        {
            ReportParameter[] parameters = new ReportParameter[1];
            
            EntitySalesOrder entitySalesOrder = new EntitySalesOrder();
            entitySalesOrder.ReadXml(Application.StartupPath + @"\DatasetSalesOrder.xml");
            //sqlDataAdapter.Fill(entitySalesOrder);
            parameters[0] = new ReportParameter("DataSource", entitySalesOrder.GetXml());
            reportViewer.ServerReport.SetParameters(parameters);
        }


        #region Events

        private void TestHarness_Load(object sender, System.EventArgs e)
        {

            LoadUserSettings();
        }

        private void TestHarness_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            SaveUserSettings();
        }
        private void button1_Click(object sender, EventArgs e)
        {
            RunRemote();
        }
        #endregion
        #region User settings persistence
        /// <summary>
        /// Gets the user preferences from the isolated storage
        /// </summary>
        void LoadUserSettings()
        {
            try
            {
                XmlDocument dom = new XmlDocument();
                using (Stream s = Util.GetSettingsStream(this.Name, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    dom.Load(s);
                }
                txtReportServer.Text = dom.SelectSingleNode("//serverName").InnerText;
                txtReportPath.Text = dom.SelectSingleNode("//reportPath").InnerText;
            }
            catch { }  // no big deal if we fail - this is a convenience feature only
        }
        /// <summary>
        /// Saves the user preferences to the isolated storage
        /// </summary>
        void SaveUserSettings()
        {
            try
            {
                using (Stream s = Util.GetSettingsStream(this.Name, FileMode.Create, FileAccess.ReadWrite, FileShare.None))
                {
                    XmlTextWriter w = new XmlTextWriter(s, System.Text.Encoding.UTF8);
                    w.WriteStartElement(this.Name);
                    w.WriteElementString("serverName", txtReportServer.Text);
                    w.WriteElementString("reportPath", txtReportPath.Text);
                    w.WriteEndElement();
                    w.Close();
                }
            }
            catch { }  // no big deal if we fail - this is a convenience feature only

        }
        #endregion

    }
}
