﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net;
using System.Security.Principal;
using Microsoft.Reporting.WebForms;

namespace AdventureWorks.Web
{
    public class MyReportServerCredentials : IReportServerCredentials
    {
        public MyReportServerCredentials()
        {

        }

        /// <summary>
        /// Impersonate user
        /// </summary>
        public WindowsIdentity ImpersonationUser
        {
            get
            {
                return null;  // Use default identity.
            }
        }

        /// <summary>
        /// Basic security
        /// </summary>
        public ICredentials NetworkCredentials
        {
            get
            {
                ///Comment out for basic security
                //// Comment out for basic security
                //CredentialCache cc = new CredentialCache();
                //cc.Add(new Uri(ConfigurationManager.AppSettings["ReportServerEndPoint"]), "Basic", new NetworkCredential("someuser", "somepassword"));
                //return cc;  // Not using NetworkCredentials to authenticate.
                return null;
            }
        }
        /// <summary>
        /// Custom security
        /// </summary>
        /// <param name="authCookie"></param>
        /// <param name="user"></param>
        /// <param name="password"></param>
        /// <param name="authority"></param>
        /// <returns></returns>
        public bool GetFormsCredentials(out Cookie authCookie, out string user, out string password, out string authority)
        {

            user = password = authority = null;
            // The cookie name is specified the <forms> element in web.config (.ASPXAUTH by default)
            HttpCookie cookie = HttpContext.Current.Request.Cookies[".ASPXAUTH"];
            if (cookie == null) HttpContext.Current.Response.Redirect("login.aspx");

            Cookie netCookie = new Cookie(cookie.Name, cookie.Value);
            if (cookie.Domain == null)
                netCookie.Domain = HttpContext.Current.Request.ServerVariables["SERVER_NAME"].ToUpper();
            netCookie.Expires = cookie.Expires;
            netCookie.Path = cookie.Path;
            netCookie.Secure = cookie.Secure;
            authCookie = netCookie;
            return true;

        }
    }
}